<style scoped lang="less">
    @import '~iview/src/styles/custom.less';
    @import './../styles/variables';
    
    .apartment {
        @card-height: 240px;
        margin: 30px 0;
        box-shadow: 0 1px 3px rgba(0,0,0,0.12), 0 1px 2px rgba(0,0,0,0.24) !important;
        border-width: 0 !important;
        cursor: pointer;
        
        .gallery {
            
            .image {
                background: #E8EAEC;
                height: @card-height !important;
                background-size: cover;
                background-position: 50% 50%;
                border-radius: 6px 0 0 6px;
            }
            
            .no-image {
                border-radius: @border-radius-base 0 0 @border-radius-base;
                background: #E8EAEC;
                height: @card-height !important;
                display: flex;
                justify-content: center;
                flex-direction: column;
                text-align: center;
            }
        }
        
        .apt-content {
            height: @card-height;
            padding: 20px;
            display: flex;
            flex-direction: column;
            justify-content: space-between;
            
            .heading {
                .muted {
                    color: @subsidiary-color;
                    font-size: 12px;
                }
            }
            
            .key-data {
                text-align: center;
                
                span:first-of-type {
                    font-size: 20px;
                    display: flex;
                    flex-direction: row;
                    align-items: center;
                    justify-content: center;
                    
                    b {
                        display: inline-block;
                        padding-right: 10px;
                    }
                }
                
                span:last-of-type {
                    display: block;
                    font-size: 11px;
                }
                
                &:not(:first-of-type) {
                    border-left: 1px solid #E8EAEC;
                }
                
                &:last-of-type span b {
                    padding-right: 0;
                }
            }
            
            .features {
                text-align: left;
                margin-top: 20px;
            }
        }
        
        .price {
            height: @card-height;
            border-left: 1px solid #E8EAEC;
            padding: 20px 25px 20px 20px !important;
            display: flex;
            align-items: flex-end;
            flex-direction: column;
            
            .pulse {
                display: flex;
                flex-direction: row;
                
                .dot {
                    position: absolute;
                    left: 20px;
                    top: 16px;
                }
                
                time {
                    font-size: 12px;
                    text-align: right;
                }
            }
            
            .cta {
                flex: 1;
                flex-direction: column;
                display: flex;
                justify-content: flex-end;
                width: 100%;
                
                .evaluation {
                    text-align: right;
                    padding-bottom: 10px;
                    font-size: 14px;
                }
            }
        }
        
        @media @mobile {
            .gallery .image {
                border-radius: 6px 6px 0 0;
            }
            
            .apt-content, .price {
                height: auto;
            }
            
            .apt-content {
                padding: 10px 20px 0 20px !important;
                
                .heading {
                    margin-bottom: 10px;
                }
                
                .features {
                    text-align: center;
                }
            }
            
            .price {
                border-left: 0;
                padding: 20px !important;
                
                .pulse {
                    order: 1;
                    display: block;
                    text-align: center;
                    width: 100%;
                    
                    .dot {
                       display: none;
                    }
                }
                
                .evaluation {
                    display: none;
                }
            }
        }
    }
    
</style>

<template>
    
    <Card class="apartment" :padding="0">
        
        <Row type="flex" justify="center" align="top" :gutter="16">
                            
            <Col :xs="24" :sm="24" :md="8" :lg="8" class="gallery">

                <div v-if="apartment.images.length > 0" class="image" v-on:click="visitExpose(apartment._id)" v-bind:style="{ backgroundImage: 'url(' + apartment.images[0].url + ')' }">
                    
                    <div style="position: absolute; bottom: 10px; left: 20px; font-size: 14px;">
                        <Tooltip :content="apartment.images.length + ' Bilder'" theme="light" placement="top-start">
                            <span style="color: white;"><Icon type="ios-photos" /> {{ apartment.images.length }}</span>
                        </Tooltip>
                    </div>
                    
                </div>
            
                <div v-else class="no-image" v-on:click="visitExpose(apartment._id)">
                    
                    <Icon type="ios-images-outline" size="32" />
                    
                </div>
            
            </Col>
        
            <Col :xs="24" :sm="24" :md="11" :lg="11" class="apt-content">
            
                <div class="heading">
                    
                    <span class="muted">{{ apartment.providerId}}</span>
                    <h4 class="truncate">{{ apartment.title }}</h4>
                    
                </div>
            
                <Row type="flex" justify="center" align="middle" :gutter="16">
                
                    <Col span="8" class="key-data">
                    
                        <span><b>{{ apartment.rooms }}</b> <Icon type="ios-photos-outline" /></span>
                        <span> Zimmer</span>
                    
                    </Col>
                    
                    <Col span="8" class="key-data">
                    
                        <span><b>{{ apartment.size }}</b> <Icon type="md-expand"></Icon></span>
                        <span>Quadratmeter</span>
                    
                    </Col>
                    
                    <Col span="8" class="key-data">
                    
                        <span><b>{{ apartment.price.cold }}</b> <Icon type="logo-euro"></Icon></span>
                        <span>Kaltmiete</span>
                    
                    </Col>
                
                </Row>
            
                <Row type="flex" align="middle" :gutter="16">
                    
                    <Col span="24">
                    
                        <ul class="features" v-if="apartment.features.length">
                            <li style="display: inline-block" v-for="feature of apartment.features">
                                <Tag>{{ feature }}</Tag>
                            </li>
                        </ul>
                    
                    </Col>
                    
                </Row>

            </Col>
            
            <Col :xs="24" :sm="24" :md="5" :lg="5" class="price">
            
                <div class="pulse">
            
                    <Badge class="dot" status="processing" />
                    <timeago :datetime="apartment.createdAt" :auto-update="60"></timeago>
                    
                </div>
            
                <div class="cta">
            
                    <span class="evaluation">Guter Preis <Icon type="ios-trending-up" /></span>
            
                    <Button :to="'/stadt/' + $route.params.cityId + '/' + apartment._id" target="_blank"  long size="large" type="primary">Ansehen</Button>                                    
                    
                </div>
            
            </Col>
            
        </Row>
        
    </Card>
    
</template>

<script>
    import Vue from 'vue';
    import VueTimeago from 'vue-timeago';
    
    Vue.use(VueTimeago, {
        name: 'Timeago',
        locale: 'de',
        locales: {
            'de': require('date-fns/locale/de'),
        }
    });    
    
    export default {
        props: {
            apartment: {
                type: Object,
                required: true
            }
        },
        data: function () {
            return {
            }
        },
        methods: {
            visitExpose (apartmentId) {
                let url = this.$router.resolve({
                    name: 'expose',
                    params: {
                        cityId: this.$route.params.cityId,
                        apartmentId: apartmentId
                    }
                });
                
                window.open(url.href, '_blank');
            }
        },
        computed: {},
        destroyed: function () {
        },
    };
</script>
